using System;
using System.Collections.Generic;
using System.Text;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Audio;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.GamerServices;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;
using Microsoft.Xna.Framework.Net;
using Microsoft.Xna.Framework.Storage;

namespace Campus
{
    class Dorm : Structure
    {
        public Dorm(Texture2D texture, Texture2D teamColorTexture, Vector2 origin, Vector2 position, Player owner, Level level)
            : base(texture, teamColorTexture, texture, new List<Vector2>(), origin, position, 500, owner, level, new Dictionary<string,Ability>(), new Dictionary<string,AbilitySubMenu>())
        {
            m_name = "Dorm";
            PlayerOwner.AddMaxFood(10);
            //TODO: create abilities
        }
        protected override void Destroy()
        {
            PlayerOwner.AddMaxFood(-10);
            base.Destroy();
        }
        public override string ToString()
        {
            string returnString = m_name + "\n" +
                                  "HP: " + m_currentHP + "/" + m_maxHP + "\n" + 
                                  "Dorms provide 10 food for building more units.";

            return returnString;
        }
        public override void Update(Player Player)
        {
            //throw new Exception("The method or operation is not implemented.");
        }
        
    }
}